diff --git a/tests/TestSuite_floating_veb.py b/tests/TestSuite_floating_veb.py
index f4d62deb..8bfc4c49 100644
--- a/tests/TestSuite_floating_veb.py
+++ b/tests/TestSuite_floating_veb.py
@@ -161,6 +161,12 @@ class TestFloatingVEBSwitching(TestCase):
         self.pf_pci = self.dut.ports_info[self.used_dut_port]['pci']
         self.path = self.dut.apps_name['test-pmd']
 
+        self.dut.init_reserved_core()
+        self.cores_vf0 = self.dut.get_reserved_core('2C', 0)
+        self.cores_vf1 = self.dut.get_reserved_core('2C', 0)
+        self.cores_vf2 = self.dut.get_reserved_core('2C', 0)
+        self.cores_vf3 = self.dut.get_reserved_core('2C', 0)
+
     def set_up(self):
         """
         This is to clear up environment before the case run.
@@ -304,14 +310,14 @@ class TestFloatingVEBSwitching(TestCase):
         self.dut.send_expect("port start all", "testpmd>")
         time.sleep(2)
         # start VF0
-        self.pmdout_2.start_testpmd("Default", prefix="test2", ports=[self.sriov_vfs_port[0].pci])
+        self.pmdout_2.start_testpmd(self.cores_vf0, prefix="test2", ports=[self.sriov_vfs_port[0].pci])
         self.session_secondary.send_expect("mac_addr add 0 %s" % self.vf0_mac, "testpmd>")
         self.session_secondary.send_expect("set fwd rxonly", "testpmd>")
         self.session_secondary.send_expect("set promisc all off", "testpmd>")
         self.session_secondary.send_expect("start", "testpmd>")
         time.sleep(2)
         # start VF1
-        self.pmdout_3.start_testpmd("Default", prefix="test3", ports=[self.sriov_vfs_port[1].pci], param="--eth-peer=0,%s" % self.vf0_mac)
+        self.pmdout_3.start_testpmd(self.cores_vf1, prefix="test3", ports=[self.sriov_vfs_port[1].pci], param="--eth-peer=0,%s" % self.vf0_mac)
         self.session_third.send_expect("set fwd txonly", "testpmd>")
         self.session_third.send_expect("set promisc all off", "testpmd>")
         self.session_third.send_expect("start", "testpmd>")
@@ -415,12 +421,12 @@ class TestFloatingVEBSwitching(TestCase):
         # VF0->VF2
         # start VF0
         self.dut.send_expect("port start all", "testpmd>")
-        self.pmdout_2.start_testpmd("Default", prefix="test2", ports=[self.sriov_vfs_port[0].pci], param="--eth-peer=0,%s" % self.vf2_mac)
+        self.pmdout_2.start_testpmd(self.cores_vf0, prefix="test2", ports=[self.sriov_vfs_port[0].pci], param="--eth-peer=0,%s" % self.vf2_mac)
         self.session_secondary.send_expect("mac_addr add 0 %s" % self.vf0_mac, "testpmd>")
         self.session_secondary.send_expect("set fwd txonly", "testpmd>")
         self.session_secondary.send_expect("set promisc all off", "testpmd>")
         # start VF2
-        self.pmdout_3.start_testpmd("Default", prefix="test3", ports=[self.sriov_vfs_port[2].pci])
+        self.pmdout_3.start_testpmd(self.cores_vf2, prefix="test3", ports=[self.sriov_vfs_port[2].pci])
         self.session_third.send_expect("mac_addr add 0 %s" % self.vf2_mac, "testpmd>")
         self.session_third.send_expect("set fwd rxonly", "testpmd>")
         self.session_third.send_expect("set promisc all off", "testpmd>")
@@ -449,12 +455,12 @@ class TestFloatingVEBSwitching(TestCase):
         # VF3->VF2
         # start VF3
         self.dut.send_expect("port start all", "testpmd>")
-        self.pmdout_2.start_testpmd("Default", prefix="test2", ports=[self.sriov_vfs_port[3].pci], param="--eth-peer=0,%s" % self.vf2_mac)
+        self.pmdout_2.start_testpmd(self.cores_vf3, prefix="test2", ports=[self.sriov_vfs_port[3].pci], param="--eth-peer=0,%s" % self.vf2_mac)
         self.session_secondary.send_expect("mac_addr add 0 %s" % self.vf0_mac, "testpmd>")
         self.session_secondary.send_expect("set fwd txonly", "testpmd>")
         self.session_secondary.send_expect("set promisc all off", "testpmd>")
         # start VF2
-        self.pmdout_3.start_testpmd("Default", prefix="test3", ports=[self.sriov_vfs_port[2].pci])
+        self.pmdout_3.start_testpmd(self.cores_vf2, prefix="test3", ports=[self.sriov_vfs_port[2].pci])
         self.session_third.send_expect("mac_addr add 0 %s" % self.vf2_mac, "testpmd>")
         self.session_third.send_expect("set fwd rxonly", "testpmd>")
         self.session_third.send_expect("set promisc all off", "testpmd>")
@@ -575,14 +581,14 @@ class TestFloatingVEBSwitching(TestCase):
         time.sleep(2)
 
         # VF2->VF1
-        self.pmdout_2.start_testpmd("Default", prefix="test2", ports=[self.sriov_vfs_port[1].pci])
+        self.pmdout_2.start_testpmd(self.cores_vf1, prefix="test2", ports=[self.sriov_vfs_port[1].pci])
         self.session_secondary.send_expect("mac_addr add 0 %s" % self.vf1_mac, "testpmd>")
         self.session_secondary.send_expect("set fwd rxonly", "testpmd>")
         self.session_secondary.send_expect("set promisc all off", "testpmd>")
         self.session_secondary.send_expect("start", "testpmd>")
         time.sleep(2)
 
-        self.pmdout_3.start_testpmd("Default", prefix="test3", ports=[self.sriov_vfs_port[2].pci], param="--eth-peer=0,%s" % self.vf1_mac)
+        self.pmdout_3.start_testpmd(self.cores_vf2, prefix="test3", ports=[self.sriov_vfs_port[2].pci], param="--eth-peer=0,%s" % self.vf1_mac)
         self.session_third.send_expect("set fwd txonly", "testpmd>")
         self.session_third.send_expect("set promisc all off", "testpmd>")
         self.session_third.send_expect("start", "testpmd>")
@@ -602,12 +608,12 @@ class TestFloatingVEBSwitching(TestCase):
         time.sleep(2)
 
         # PF link down, VF2->VF1
-        self.pmdout_2.start_testpmd("Default", prefix="test2", ports=[self.sriov_vfs_port[1].pci])
+        self.pmdout_2.start_testpmd(self.cores_vf1, prefix="test2", ports=[self.sriov_vfs_port[1].pci])
         self.session_secondary.send_expect("mac_addr add 0 %s" % self.vf1_mac, "testpmd>")
         self.session_secondary.send_expect("set fwd rxonly", "testpmd>")
         self.session_secondary.send_expect("set promisc all off", "testpmd>")
 
-        self.pmdout_3.start_testpmd("Default", prefix="test3", ports=[self.sriov_vfs_port[2].pci], param="--eth-peer=0,%s" % self.vf1_mac)
+        self.pmdout_3.start_testpmd(self.cores_vf2, prefix="test3", ports=[self.sriov_vfs_port[2].pci], param="--eth-peer=0,%s" % self.vf1_mac)
         self.session_third.send_expect("set fwd txonly", "testpmd>")
         self.session_third.send_expect("set promisc all off", "testpmd>")
         